DEFINE V320x200, 1;						// Auflsungsmglichkeit 320x200
DEFINE V320x240, 2;						// Auflsungsmglichkeit 320x240
DEFINE V320x400, 3;						// Auflsungsmglichkeit 320x400
DEFINE V400x300, 4;						// Auflsungsmglichkeit 400x300
DEFINE V512x384, 5;						// Auflsungsmglichkeit 512x384
DEFINE V640x480, 6;						// Auflsungsmglichkeit 640x480
DEFINE V800x600, 7;						// Auflsungsmglichkeit 800x600 (Start einstellung)
DEFINE V1024x768, 8;						// Auflsungsmglichkeit 1024x768
DEFINE V1280x960, 9;						// Auflsungsmglichkeit 1280x960
DEFINE V1600x1200, 10;						// Auflsungsmglichkeit 1600x1200
VAR Video_Mode = V640x480;					// Die Bildschirmauflsung beim Spiel
VAR Video_Depth = 16;						// Bildschirm Bit Farbe!
								// (Fr 16Bit wird DirecX gebraucht)
VAR Video_FullScreen = No;					// Vollbild Modus eingeschaltet!
VAR Snake_Speed = 5;
VAR SnakeLong = 1;
VAR Item_Now = 0;
VAR Item_Max = 0;
VAR NowWait = 0;
VAR Stop = 0;
VAR HoleItem = 2;
VAR Level = 4;
VAR GameOver = 0;
VAR Gamer[3] = 0,0,0;
VAR Cam_Start[3] = 0,0,0;
VAR Cam_Move[3] = 0,0,0;
VAR Camera_Art = 0;
VAR Rain = 0;
VAR Rain_Sound_Result = 0;
VAR Show_Kris = 0;
VAR Score = 0;
VAR Lives = 6;
VAR NowNum = 0;
VAR FileHandle_Score = 0;
VAR ScoreView = 0;
VAR Templine = 0;
VAR Blender = 0;
VAR ItColi = 0;

STRING SpaltDown = "\n";
STRING LevelName = "lev001.wmb";

STRING ScoreName_A = "None      ";
STRING ScoreName_B = "None      ";
STRING ScoreName_C = "None      ";
STRING ScoreName_D = "None      ";
STRING ScoreName_E = "None      ";
STRING ScoreName_F = "None      ";
STRING ScoreName_G = "None      ";
STRING ScoreName_H = "None      ";
STRING ScoreName_I = "None      ";

STRING MomStr = "";

VAR ScoreNum_A = 12000;
VAR ScoreNum_B = 10000;
VAR ScoreNum_C = 9000;
VAR ScoreNum_D = 7000;
VAR ScoreNum_E = 5500;
VAR ScoreNum_F = 4700;
VAR ScoreNum_G = 3500;
VAR ScoreNum_H = 2000;
VAR ScoreNum_I = 1000;
VAR ScoreEdit = 0;

STRING ScoreEdit_A = "";
STRING ScoreEdit_B = "";
STRING ScoreEdit_C = "";
STRING ScoreEdit_D = "";
STRING ScoreEdit_E = "";
sound Rain_Sound = <rain.wav>;
sound Blitz_Sound = <blitz.wav>;
sound EffektScoreA_Sound = <effekt1.wav>;
sound EffektScoreB_Sound = <effekt2.wav>;
sound EffektWormA_Sound = <effekt3.wav>;
sound GameEnd_Sound = <effekt4.wav>;
sound GameOver_Sound = <effekt5.wav>;
sound GameSongA_Sound = <song1.wav>;

bmap GameOver_Bmp = <gameover.bmp>;
bmap NextLev_Bmp = <nextlev.bmp>;
bmap Winning_Bmp = <winning.bmp>;
bmap Sky_Bmp =  <sky1.pcx>;
bmap BackGround_BMAP = <blender.bmp>;
bmap LogoA_Bmp = <logo1.bmp>;
bmap LogoB_Bmp = <logo2.bmp>;
bmap LogoC_Bmp = <logo3.bmp>;

font Font_A, <fonta.bmp>, 25, 26;
font Font_B, <fontb.bmp>, 16, 18;

text View_HighText
{
	font = Font_A;
	pos_y = 400;
	pos_x = 183;
	string = "Bitte drcken Sie\n  eine Taste!!!";
	flags = d3d;
}

Text Life_A
{
	pos_x = 5;
	pos_y = 5;
	font = Font_A;
	string = "Leben:       Kris.:\nPunkte:      Level:";
	flags = visible, d3d;
}

Panel Life_B
{
	pos_x = 0;
	pos_y = 0;
	DIGITS 200,5,3,Font_A,1,Lives;
	DIGITS 150,31,6,Font_A,1,Score;
	DIGITS 532,31,3,Font_A,1,Level;
	DIGITS 532,5,3,Font_A,1,Show_Kris;
	flags = visible, refresh, d3d;
}

Panel BackGround { pos_x = 0; pos_y = 0; bmap = BackGround_BMAP; flags = transparent, visible, refresh, d3d; layer = -1; }
Panel LogoA_Panel { pos_x = 0; pos_y = 0; bmap = LogoA_bmp; flags = transparent, visible, refresh, d3d; }
Panel LogoB_Panel { pos_x = 0; pos_y = 0; bmap = LogoB_bmp; flags = transparent, visible, refresh, d3d; }
Panel LogoC_Panel { pos_x = 0; pos_y = 0; bmap = LogoC_bmp; flags = transparent, visible, refresh, d3d; }

Panel Highscore
{
	pos_x = 0;
	pos_y = 0;
	DIGITS 450,150,6,Font_A,1,ScoreNum_A;
	DIGITS 450,175,6,Font_A,1,ScoreNum_B;
	DIGITS 450,200,6,Font_A,1,ScoreNum_C;
	DIGITS 450,225,6,Font_A,1,ScoreNum_D;
	DIGITS 450,250,6,Font_A,1,ScoreNum_E;
	DIGITS 450,275,6,Font_A,1,ScoreNum_F;
	DIGITS 450,300,6,Font_A,1,ScoreNum_G;
	DIGITS 450,325,6,Font_A,1,ScoreNum_H;
	DIGITS 450,350,6,Font_A,1,ScoreNum_I;
	flags = visible, refresh, d3d;
}

text View_HightScore { font = Font_A; flags = visible, d3d; pos_y = 100; pos_x = 275; string = "High Score"; }
text View_Score_A { font = Font_A; flags = visible, d3d; pos_y = 150; pos_x = 200; string = ScoreName_A; }
text View_Score_B { font = Font_A; flags = visible, d3d; pos_y = 175; pos_x = 200; string = ScoreName_B; }
text View_Score_C { font = Font_A; flags = visible, d3d; pos_y = 200; pos_x = 200; string = ScoreName_C; }
text View_Score_D { font = Font_A; flags = visible, d3d; pos_y = 225; pos_x = 200; string = ScoreName_D; }
text View_Score_E { font = Font_A; flags = visible, d3d; pos_y = 250; pos_x = 200; string = ScoreName_E; }
text View_Score_F { font = Font_A; flags = visible, d3d; pos_y = 275; pos_x = 200; string = ScoreName_F; }
text View_Score_G { font = Font_A; flags = visible, d3d; pos_y = 300; pos_x = 200; string = ScoreName_G; }
text View_Score_H { font = Font_A; flags = visible, d3d; pos_y = 325; pos_x = 200; string = ScoreName_H; }
text View_Score_I { font = Font_A; flags = visible, d3d; pos_y = 350; pos_x = 200; string = ScoreName_I; }

text View_Winning_Text { font = Font_A; flags = visible, d3d; pos_y = 100; pos_x = 275; string = "Gewonnen !"; }

Panel GameOver_Pan
{
	pos_x = 145;
	pos_y = 190;
	bmap = GameOver_Bmp;
	flags = refresh, d3d;
}

Panel NextLev_Pan
{
	pos_x = 145;
	pos_y = 190;
	bmap = NextLev_Bmp;
	flags = refresh, d3d;
}

Panel Winning_Pan
{
	pos_x = 145;
	pos_y = 190;
	bmap = Winning_Bmp;
	flags = refresh, d3d;
}

text ViewIntro_PressKey { font = Font_A; flags = visible, d3d; pos_y = 400; pos_x = 100; string = "Bitte eine Taste Drcken"; }
text ViewIntro_Text { font = Font_B; flags = visible, d3d; pos_y = 0; pos_x = 90; string = ""; }

function Load_Lev()
{
	ShowLife_On();
	Rain = 0;
	if (Level == 1) { level_load("lev001.wmb"); Rain = 1; }
	if (Level == 2) { level_load("lev002.wmb"); Rain = 1; }
	if (Level == 3) { level_load("lev003.wmb"); Rain = 1; }
	if (Level == 4) { level_load("lev004.wmb"); Rain = 1; }
	if (Level == 5) { level_load("lev005.wmb"); Rain = 1; }
	if (Level == 6)
	{
		ShowLife_Off();
		Rain = 1;
		Stop = 1;
		Enter_Score();
		while (Stop == 1) { wait 1; }

		Stop = 1;
		View_Winning_Text.Transparent = on;
		View_Winning_Text.alpha = 0;
		View_Winning_Text.visible = on;
		while (View_Winning_Text.alpha < 100)
		{
			View_Winning_Text.alpha += 1;
			wait 1;
		}
		wait 350;
		while (View_Winning_Text.alpha > 0)
		{
			View_Winning_Text.alpha -= 1;
			wait 1;
		}
		while (Blender > 0) { Blender -= 0.5; wait 1; }
		Rain = 1;
		Stop = 0;
		level_load("start.wmb"); Rain = 1; Stop = 0; wait 1;
	}
}

function HighScore_Load()
{
	FileHandle_Score = file_open_read("score.txt");
	if (FileHandle_Score)
	{
			File_Str_Read(FileHandle_Score, ScoreName_A);
			File_Str_Read(FileHandle_Score, ScoreName_B);
			File_Str_Read(FileHandle_Score, ScoreName_C);
			File_Str_Read(FileHandle_Score, ScoreName_D);
			File_Str_Read(FileHandle_Score, ScoreName_E);
			File_Str_Read(FileHandle_Score, ScoreName_F);
			File_Str_Read(FileHandle_Score, ScoreName_G);
			File_Str_Read(FileHandle_Score, ScoreName_H);
			File_Str_Read(FileHandle_Score, ScoreName_I);

			ScoreNum_A = File_Var_Read(FileHandle_Score);
			ScoreNum_B = File_Var_Read(FileHandle_Score);
			ScoreNum_C = File_Var_Read(FileHandle_Score);
			ScoreNum_D = File_Var_Read(FileHandle_Score);
			ScoreNum_E = File_Var_Read(FileHandle_Score);
			ScoreNum_F = File_Var_Read(FileHandle_Score);
			ScoreNum_G = File_Var_Read(FileHandle_Score);
			ScoreNum_H = File_Var_Read(FileHandle_Score);
			ScoreNum_I = File_Var_Read(FileHandle_Score);
		file_close(FileHandle_Score);
	}
}

function Highscore_Save()
{
	FileHandle_Score = file_open_write("score.txt");
		File_Str_Write(FileHandle_Score, ScoreName_A);
		File_Str_Write(FileHandle_Score, "\n");
		File_Str_Write(FileHandle_Score, ScoreName_B);
		File_Str_Write(FileHandle_Score, "\n");
		File_Str_Write(FileHandle_Score, ScoreName_C);
		File_Str_Write(FileHandle_Score, "\n");
		File_Str_Write(FileHandle_Score, ScoreName_D);
		File_Str_Write(FileHandle_Score, "\n");
		File_Str_Write(FileHandle_Score, ScoreName_E);
		File_Str_Write(FileHandle_Score, "\n");
		File_Str_Write(FileHandle_Score, ScoreName_F);
		File_Str_Write(FileHandle_Score, "\n");
		File_Str_Write(FileHandle_Score, ScoreName_G);
		File_Str_Write(FileHandle_Score, "\n");
		File_Str_Write(FileHandle_Score, ScoreName_H);
		File_Str_Write(FileHandle_Score, "\n");
		File_Str_Write(FileHandle_Score, ScoreName_I);
		File_Str_Write(FileHandle_Score, "\n");
		File_Var_Write(FileHandle_Score, ScoreNum_A);
		File_Str_Write(FileHandle_Score, "\n");
		File_Var_Write(FileHandle_Score, ScoreNum_B);
		File_Str_Write(FileHandle_Score, "\n");
		File_Var_Write(FileHandle_Score, ScoreNum_C);
		File_Str_Write(FileHandle_Score, "\n");
		File_Var_Write(FileHandle_Score, ScoreNum_D);
		File_Str_Write(FileHandle_Score, "\n");
		File_Var_Write(FileHandle_Score, ScoreNum_E);
		File_Str_Write(FileHandle_Score, "\n");
		File_Var_Write(FileHandle_Score, ScoreNum_F);
		File_Str_Write(FileHandle_Score, "\n");
		File_Var_Write(FileHandle_Score, ScoreNum_G);
		File_Str_Write(FileHandle_Score, "\n");
		File_Var_Write(FileHandle_Score, ScoreNum_H);
		File_Str_Write(FileHandle_Score, "\n");
		File_Var_Write(FileHandle_Score, ScoreNum_I);
		File_Str_Write(FileHandle_Score, "\n");
	file_close(FileHandle_Score);
}

function drop_event
{
	remove my;
}

function drop_function
{
	my.passable = on;
	my.transparent = on;
	my.alpha = 100;
	my.x += random(200) - 100;
	my.y += random(200) - 100;
	my.event = drop_event;
	my.enable_block = on;
	while (my.alpha > 0)
	{
		temp.y = random(1);
		temp.x = random(1);
		temp.z = -32 * time;
		move my, temp, nullvector;
		my.alpha -= 0.5;
		wait 1;
	}
	remove my;
}

function ShowScore_Off()
{
	Highscore.alpha = 100;
	View_HightScore.alpha = 100;
	View_Score_A.alpha = 100;
	View_Score_B.alpha = 100;
	View_Score_C.alpha = 100;
	View_Score_D.alpha = 100;
	View_Score_E.alpha = 100;
	View_Score_F.alpha = 100;
	View_Score_G.alpha = 100;
	View_Score_H.alpha = 100;
	View_Score_I.alpha = 100;
	View_HighText.alpha = 100;
	ScoreView = 0;
	wait 1;
	ScoreView = 1;
	while (Highscore.alpha > 0 && ScoreView == 1)
	{
			Highscore.Visible = on;
			View_HightScore.Visible = on;
			View_Score_A.Visible = on;
			View_Score_B.Visible = on;
			View_Score_C.Visible = on;
			View_Score_D.Visible = on;
			View_Score_E.Visible = on;
			View_Score_F.Visible = on;
			View_Score_G.Visible = on;
			View_Score_H.Visible = on;
			View_Score_I.Visible = on;
			View_HighText.Visible = on;

			Highscore.Transparent = on;
			View_HightScore.Transparent = on;
			View_Score_A.Transparent = on;
			View_Score_B.Transparent = on;
			View_Score_C.Transparent = on;
			View_Score_D.Transparent = on;
			View_Score_E.Transparent = on;
			View_Score_F.Transparent = on;
			View_Score_G.Transparent = on;
			View_Score_H.Transparent = on;
			View_Score_I.Transparent = on;
			View_HighText.Transparent = on;

			Highscore.alpha -= 1;
			View_HightScore.alpha -= 1;
			View_Score_A.alpha -= 1;
			View_Score_B.alpha -= 1;
			View_Score_C.alpha -= 1;
			View_Score_D.alpha -= 1;
			View_Score_E.alpha -= 1;
			View_Score_F.alpha -= 1;
			View_Score_G.alpha -= 1;
			View_Score_H.alpha -= 1;
			View_Score_I.alpha -= 1;
			View_HighText.alpha -= 1;
			wait 1;
	}
}

function ShowScore_On()
{
	showlife_off();
	Highscore.alpha = 0;
	View_HightScore.alpha = 0;
	View_Score_A.alpha = 0;
	View_Score_B.alpha = 0;
	View_Score_C.alpha = 0;
	View_Score_D.alpha = 0;
	View_Score_E.alpha = 0;
	View_Score_F.alpha = 0;
	View_Score_G.alpha = 0;
	View_Score_H.alpha = 0;
	View_Score_I.alpha = 0;
	View_HighText.alpha = 0;
	ScoreView = 0;
	wait 1;
	ScoreView = 1;
	while (Highscore.alpha < 100 && ScoreView == 1)
	{
			Highscore.Visible = on;
			View_HightScore.Visible = on;
			View_Score_A.Visible = on;
			View_Score_B.Visible = on;
			View_Score_C.Visible = on;
			View_Score_D.Visible = on;
			View_Score_E.Visible = on;
			View_Score_F.Visible = on;
			View_Score_G.Visible = on;
			View_Score_H.Visible = on;
			View_Score_I.Visible = on;
			View_HighText.Visible = on;

			Highscore.Transparent = on;
			View_HightScore.Transparent = on;
			View_Score_A.Transparent = on;
			View_Score_B.Transparent = on;
			View_Score_C.Transparent = on;
			View_Score_D.Transparent = on;
			View_Score_E.Transparent = on;
			View_Score_F.Transparent = on;
			View_Score_G.Transparent = on;
			View_Score_H.Transparent = on;
			View_Score_I.Transparent = on;
			View_HighText.Transparent = on;

			Highscore.alpha += 1;
			View_HightScore.alpha += 1;
			View_Score_A.alpha += 1;
			View_Score_B.alpha += 1;
			View_Score_C.alpha += 1;
			View_Score_D.alpha += 1;
			View_Score_E.alpha += 1;
			View_Score_F.alpha += 1;
			View_Score_G.alpha += 1;
			View_Score_H.alpha += 1;
			View_Score_I.alpha += 1;
			View_HighText.alpha += 1;
			wait 1;
	}
}

function ShowLife_Off()
{
	Life_A.visible = off;
	Life_B.visible = off;
}

function ShowLife_On()
{
	Life_A.visible = on;
	Life_B.visible = on;
	ViewIntro_PressKey.visible = off;
}

function main()
{
	switch_video(V800x600, 16, 1);
	D3D_Panels = on;
	Max_Entities = 8000;
	FPS_Max = 75;
	FPS_Min = 15;
//	Play_Song(SongA_Music, 85);
	Life_A.Visible = on;
	Life_B.Visible = on;
	View_Winning_Text.visible = off;
	Highscore.Visible = off;
	View_HightScore.Visible = off;
	View_Score_A.Visible = off;
	View_Score_B.Visible = off;
	View_Score_C.Visible = off;
	View_Score_D.Visible = off;
	View_Score_E.Visible = off;
	View_Score_F.Visible = off;
	View_Score_G.Visible = off;
	View_Score_H.Visible = off;
	View_Score_I.Visible = off;
	LogoA_Panel.Transparent = on;
	LogoA_Panel.Alpha = 0;
	LogoB_Panel.Transparent = on;
	LogoB_Panel.Alpha = 0;
	LogoC_Panel.Transparent = on;
	LogoC_Panel.Alpha = 0;
	LogoB_Panel.Visible = off;
	LogoC_Panel.Visible = off;
	showlife_off();
	ViewIntro_PressKey.visible = off;
	wait 32;
	while (LogoA_Panel.Alpha < 100) { LogoA_Panel.Alpha += 2 * time; wait 1; }
	wait 64;
	while (LogoA_Panel.Alpha > 0) { LogoA_Panel.Alpha -= 2 * time; wait 1; }
	LogoA_Panel.Visible = off;
	wait 1;
	LogoB_Panel.Visible = on;
	while (LogoB_Panel.Alpha < 100) { LogoB_Panel.Alpha += 2 * time; wait 1; }
	wait 64;
	LogoC_Panel.Visible = on;
	while (LogoB_Panel.Alpha > 0) { LogoB_Panel.Alpha -= 2 * time; LogoC_Panel.Alpha += 2 * time; wait 1; }
	LogoB_Panel.Visible = off;
	wait 64;
	while (LogoC_Panel.Alpha > 0) { LogoC_Panel.Alpha -= 2 * time; wait 1; }
	LogoC_Panel.Visible = off;
	HighScore_Load();
	level_load("start.wmb"); Rain = 1;
	ViewIntro_PressKey.visible = on;
	showlife_off();
	wait 1;
	Cam_Start.x = camera.x;
	Cam_Start.y = camera.y;
	Cam_Start.z = camera.z;
	BackGround.Transparent = on;
	play_loop(GameSongA_Sound, 100);
	play_loop(Rain_Sound, 100);
	Rain_Sound_Result = result;
	while (1)
	{
		while (Rain == 1)
		{
			temp.y = camera.y;
			temp.x = camera.x;
			temp.z = camera.z;
			create "drop.mdl", temp, drop_function;
			BackGround.alpha = 100 - Blender;
			wait 1;
		}
		Stop_Sound(Rain_Sound_Result);
		while (Rain == 0)
		{
			wait 1;
		}
		wait 1;
	}
}

function Snake2
{
	my.passable = on;
	my.pan = your.pan;
	my.tilt = your.tilt;
	my.roll = your.roll;
	my.transparent = on;
	my.alpha = 25;
	wait 1;
	my.alpha = 50;
	wait 1;
	my.alpha = 75;
	wait 1;
	my.alpha = 100;
	while (my.skill2 < 80)
	{
		my.skill2 += 1;
		my.roll = ang(my.roll + random(4) - 2);
		wait 1;
	}
	my.passable = off;
	my.frame = 0;
	my.skill1 = (10 * SnakeLong) - 4 - 80;
	while (my.skill1 > 0)
	{
		my.skill1 -= 1;
		my.roll = ang(my.roll + random(4) - 2);
		while (Stop == 1) { wait 1; }
		wait 1;
	}
	my.passable = on;
	my.alpha = 100;	
	while (my.alpha > 0)
	{
		my.alpha -= 10 * time;
		while (Stop == 1) { wait 1; }
		wait 1;
	}
	my.alpha = 0;
	wait 1;
	remove my;
}

action Item_Long
{
	Item_Max += 1;
	my.passable = on;
	my.invisible = on;
	while (my.skill1 != Item_Now)
	{
		wait 1;
	}
	my.invisible = off;

	temp.x = gamer.x;
	temp.y = gamer.y;
	temp.z = gamer.z;
	result = vec_dist(my.pos, gamer);
	while (vec_dist(my.pos, gamer) > 25)
	{
		wait 1;
	}
	play_sound(EffektScoreA_Sound, 100);
	Item_Now += 1;
	SnakeLong += 7;
	Snake_Speed += 0.5;
	HoleItem = 1;
	my.passable = on;
	wait 1;
	my.transparent = on;
	my.alpha = 100;
	Life_B.Transparent = on;
	Life_B.Alpha = 50;
//	score += 50 * Item_Now;
	wait 3;
	Life_B.Alpha = 100;
	Life_B.Transparent = off;
	while (my.alpha > 0)
	{

		my.alpha -= 8;
		temp = 50 * Item_Now;
		score += temp / (100 / 8);
		wait 1;
	}
	remove my;
}

action Score_50
{
	my.skill2 = my.z;
	my.passable = on;
	my.transparent = on;
	my.z += 400;
	my.alpha = 0;
	while (my.skill1 != Item_Now)
	{
		wait 1;
	}
	while (my.skill2 < my.z)
	{
		my.z -= random(3) + 1;
		if (my.alpha < 100) { my.alpha += 1; }
		wait 1;
	}
	my.alpha = 100;
	temp.x = gamer.x;
	temp.y = gamer.y;
	temp.z = gamer.z;
	while (vec_dist(my.pos, gamer) > 25)
	{
		my.pan += 5 * time;
		wait 1;
	}
	play_sound(EffektScoreA_Sound, 100);
	while (my.alpha > 0)
	{
		my.z += 2;
		my.tilt += 5;
		my.roll += 5;
		my.alpha -= 1;
		score += 50 / 100;
		wait 1;
	}
	Stop_Sound(result);
	remove my;
}

function GameOver_Snake()
{
	GameOver = 1;
	Stop = 1;
	play_entsound(my, EffektWormA_Sound, 1000);
	while (Blender > 0) { Blender -= 0.5; wait 1;}
	Stop = 0;
	GameOver = 0;
	Snake_Speed = 5;
	SnakeLong = 1;
	Item_Now = 0;
	Item_Max = 0;
	HoleItem = 2;
	NowWait = 0;
	Stop = 0;
	Lives -= 1;
	if (Lives > 0)
	{
		Score -= 50;
		if (score < 0) { score = 0; }
		Load_Lev();
	}
	else
	{
		play_sound(GameOver_Sound, 125);
		Enter_Score();
		while (Stop == 1) { wait 1; }
		level_load("start.wmb"); Rain = 1;
	}
	wait 1;
}

function Camera_View()
{
	if (Camera_Art == 0)
	{
		my.invisible = off;
		Camera.x = my.x;
		Camera.y = my.y;
		Camera.z = Cam_Start.z;
		Camera.Tilt = -90;
		Camera.Pan = 0;
		Camera.Roll = 0;
		return;
	}

	if (Camera_Art == 1)
	{
		camera.x = my.x;
		camera.y = my.y;
		camera.z = my.z;
		camera.pan = my.pan;
		camera.tilt = my.tilt;
		camera.roll = my.roll;
		my.invisible = on;
	}

	if (Camera_Art == 2)
	{
		my.invisible = off;
		camera.pan = 0;
		camera.roll = 0;
		camera.tilt = -90;
		camera.z = Cam_Start.z;

		cam_move.x = int(my.x / 100) * 100;
		cam_move.y = int(my.y / 100) * 100;

		if (camera.x < cam_move.x) { camera.x += (Snake_Speed * 2) * TIME; }
		if (camera.x > cam_move.x) { camera.x -= (Snake_Speed * 2) * TIME; }
		if (camera.y < cam_move.y) { camera.y += (Snake_Speed * 2) * TIME; }
		if (camera.y > cam_move.y) { camera.y -= (Snake_Speed * 2) * TIME; }
		return;
	}
}

function Enter_Score()
{
	Stop = 1;
	if (ScoreNum_I < Score)
	{
		NowNum = 0;
		if (Score > ScoreNum_H) { NowNum = 1; }
		if (Score > ScoreNum_G) { NowNum = 2; }
		if (Score > ScoreNum_F) { NowNum = 3; }
		if (Score > ScoreNum_E) { NowNum = 4; }
		if (Score > ScoreNum_D) { NowNum = 5; }
		if (Score > ScoreNum_C) { NowNum = 6; }
		if (Score > ScoreNum_B) { NowNum = 7; }
		if (Score > ScoreNum_A) { NowNum = 8; }

		if (NowNum > 0) { ScoreNum_I = ScoreNum_H; str_cpy(ScoreName_I, ScoreName_H); }
		if (NowNum > 1) { ScoreNum_H = ScoreNum_G; str_cpy(ScoreName_H, ScoreName_G); }
		if (NowNum > 2) { ScoreNum_G = ScoreNum_F; str_cpy(ScoreName_G, ScoreName_F); }
		if (NowNum > 3) { ScoreNum_F = ScoreNum_E; str_cpy(ScoreName_F, ScoreName_E); }
		if (NowNum > 4) { ScoreNum_E = ScoreNum_D; str_cpy(ScoreName_E, ScoreName_D); }
		if (NowNum > 5) { ScoreNum_D = ScoreNum_C; str_cpy(ScoreName_D, ScoreName_C); }
		if (NowNum > 6) { ScoreNum_C = ScoreNum_B; str_cpy(ScoreName_C, ScoreName_B); }
		if (NowNum > 7) { ScoreNum_B = ScoreNum_A; str_cpy(ScoreName_B, ScoreName_A); }

		if (NowNum == 0) { ScoreNum_I = Score; }
		if (NowNum == 1) { ScoreNum_H = Score; }
		if (NowNum == 2) { ScoreNum_G = Score; }
		if (NowNum == 3) { ScoreNum_F = Score; }
		if (NowNum == 4) { ScoreNum_E = Score; }
		if (NowNum == 5) { ScoreNum_D = Score; }
		if (NowNum == 6) { ScoreNum_C = Score; }
		if (NowNum == 7) { ScoreNum_B = Score; }
		if (NowNum == 8) { ScoreNum_A = Score; }
		View_HighText.String = " Bitte den Namen\n   eingeben!!!";
		ShowScore_On();
		while (key_any)
		{
			wait 1;
		}

		while (result != 13)
		{
			wait 1;
			if (NowNum == 0) { inkey ScoreName_I; }
			if (NowNum == 1) { inkey ScoreName_H; }
			if (NowNum == 2) { inkey ScoreName_G; }
			if (NowNum == 3) { inkey ScoreName_F; }
			if (NowNum == 4) { inkey ScoreName_E; }
			if (NowNum == 5) { inkey ScoreName_D; }
			if (NowNum == 6) { inkey ScoreName_C; }
			if (NowNum == 7) { inkey ScoreName_B; }
			if (NowNum == 8) { inkey ScoreName_A; }
		}
		View_HighText.String = "Bitte drcken Sie\n  eine Taste!!!";
		wait 1;
		while (key_any)
		{
			wait 1;
		}
		while (!key_any)
		{
			wait 1;
		}
		ShowScore_Off();
		while (Highscore.alpha > 0) { wait 1; }
	}
	else
	{
		View_HighText.String = "Bitte drcken Sie\n  eine Taste!!!";
		ShowScore_On();
		while (key_any)
		{
			wait 1;
		}
		while (!key_any)
		{
			wait 1;
		}
		ShowScore_Off();
		while (Highscore.alpha > 0) { wait 1; }
	}
	Stop = 0;
	wait 1;
}

action Snake
{
	wait 1;
/*
	my.event = GameOver_Snake;
	my.enable_impact = on;
	my.enable_block = on;
	my.enable_entity = on;
*/
	my.passable = on;
	while (GameOver == 0)
	{
		while (stop == 1) { wait 1; }
		if (Blender < 100) { Blender += 0.5; }
		Show_Kris = Item_Max - Item_Now;
		temp.x = Snake_Speed * TIME;
		temp.y = 0;
		temp.z = 0;
		move my, temp, nullvector;
		my.pan -= (key_force.x * 12.0) * time;
		my.skill8 = key_force.x * 50.0;
		if (my.roll < my.skill8) { my.roll += 9 * time; }
		if (my.roll > my.skill8) { my.roll -= 9 * time; }
		Camera_View();

		temp = Snake_Speed * TIME;
		my.skill1 += 1;
		if (my.skill1 > 8 / temp)
		{
			create "snake2.mdl", my.pos, Snake2;
			my.skill1 = 0;
		}

		if (Item_Now == Item_Max)
		{
			my.event = null;
			my.roll = 0;
			my.tilt = 0;
			Stop = 1;
			while (Blender > 0) { Blender -= 0.5; wait 1; }
			Snake_Speed = 5;
			SnakeLong = 1;
			Item_Now = 0;
			Item_Max = 0;
			HoleItem = 2;
			NowWait = 0;
			Stop = 0;
			Level += 1;
			Load_Lev();
		}
		gamer.x = my.x;
		gamer.y = my.y;
		gamer.z = my.z;

		my.skill2 += 1 * time;
		if (my.skill2 > 100) { my.skill2 -= 100; }
		ent_cycle("stand", my.skill2);

		if (key_esc)
		{
			while (Blender > 0) { Blender -= 0.5; wait 1; }
			level_load("start.wmb"); Rain = 1;
		}

		ItColi = 0;

		vec_set(temp, my.x);
		temp.y += sin(my.pan + 8) * 50;
		temp.x += cos(my.pan + 8) * 50;
		trace_mode = ignore_me + ignore_passable;
		result = trace(my.x, temp);
		if (result > 0 && result < 20) { ItColi = 1; }

		vec_set(temp, my.x);
		temp.y += sin(my.pan) * 50;
		temp.x += cos(my.pan) * 50;
		trace_mode = ignore_me + ignore_passable;
		result = trace(my.x, temp);
		if (result > 0 && result < 20) { ItColi = 1; }

		vec_set(temp, my.x);
		temp.y += sin(my.pan - 8) * 50;
		temp.x += cos(my.pan - 8) * 50;
		trace_mode = ignore_me + ignore_passable;
		result = trace(my.x, temp);
		if (result > 0 && result < 20) { ItColi = 1; }

		if (ItColi == 1) { GameOver_Snake(); }
		wait 1;
	}
	wait 1;
}

action Snake_Intro
{
	ViewIntro_PressKey.visible = on;
	ViewIntro_PressKey.transparent = on;
	ViewIntro_PressKey.alpha = 0;
	ViewIntro_Text.visible = on;
	ViewIntro_Text.transparent = on;
	ViewIntro_Text.alpha = 0;
	ViewIntro_Text.pos_y = 0;
	showlife_off();
	ShowScore_On();
	View_HighText.String = "";
	Blender = 1;
	stop = 0;
	while (GameOver == 0)
	{
		if (Blender < 100) { Blender += 0.5; }
		Show_Kris = Item_Max - Item_Now;
		temp.x = Snake_Speed * time;
		temp.y = 0;
		temp.z = 0;
		move my, temp, nullvector;
		my.pan -= 4.0 * time;

		my.skill1 += 1;
		temp = Snake_Speed * time;
		if (my.skill1 > 8 / temp)
		{
			create "snake2.mdl", my.pos, Snake2;
			my.skill1 = 0;
		}

		gamer.x = my.x;
		gamer.y = my.y;
		gamer.z = my.z;

		my.skill2 += 1 * time;
		if (my.skill2 > 100) { my.skill2 -= 100; }
		ent_cycle("stand", my.skill2);

		if (my.skill5 == 0)
		{
			ViewIntro_PressKey.alpha += 2;
			if (ViewIntro_PressKey.alpha > 76) { my.skill5 = 1; }
		}
		else
		{
			ViewIntro_PressKey.alpha -= 2;
			if (ViewIntro_PressKey.alpha < 60) { my.skill5 = 0; }
		}		
		
		if (my.skill6 == 14) { my.skill6 = 0; }
		if (my.skill6 == 0) { ViewIntro_Text.String = "           SNAKE - The Clone"; }
		if (my.skill6 == 1) { ViewIntro_Text.String = "       An einen  Regnerischen Tag"; }
		if (my.skill6 == 2) { ViewIntro_Text.String = "   schlngelst du dich langsam vor."; }
		if (my.skill6 == 3) { ViewIntro_Text.String = " Am Bauernhof angekommen, sammelst du"; }
		if (my.skill6 == 4) { ViewIntro_Text.String = "      alles was man finden kann."; }
		if (my.skill6 == 5) { ViewIntro_Text.String = "      Der besitzer bemerkt dich!"; }
		if (my.skill6 == 6) { ViewIntro_Text.String = "            und wird Wtend."; }
		if (my.skill6 == 7) { ViewIntro_Text.String = "    vor Wut hat er dich verflucht."; }
		if (my.skill6 == 8) { ViewIntro_Text.String = " Nun darfst du nicht mehr mit Irgend-"; }
		if (my.skill6 == 9) { ViewIntro_Text.String = "  etwas (auer dem Boden) im kontakt"; }
		if (my.skill6 == 10) { ViewIntro_Text.String = "    kommen. Denn sonst Stirbst du!"; }
		if (my.skill6 == 11) { ViewIntro_Text.String = " Dieser Fluch wird aufgehoben, wenn du"; }
		if (my.skill6 == 12) { ViewIntro_Text.String = "   genug Vitamin Kristalle gesammelt"; }
		if (my.skill6 == 13) { ViewIntro_Text.String = "                 hast."; }
		ViewIntro_Text.pos_y += 0.25;
		if (my.skill7 == 0)
		{
			ViewIntro_Text.alpha += 1;
			if (ViewIntro_Text.alpha > 100) { ViewIntro_Text.alpha = 100; }
		}
		else
		{
			ViewIntro_Text.alpha -= 1;
			if (ViewIntro_Text.alpha < 0) { ViewIntro_Text.alpha = 0; }
		}

		my.skill8 += 0.5;
		if (my.skill8 > 125) { if (My.skill7 == 0) { my.skill7 = 1; } else { my.skill7 = 0; ViewIntro_Text.pos_y = 0; } my.skill8 = 0; my.skill6 += 0.5; }

		if (key_esc)
		{
			Highscore_Save();
			play_sound(GameEnd_Sound, 150);
			ShowScore_Off();
			stop = 1;
			while (Blender > 0)
			{
				if (ViewIntro_Text.Alpha > 0) { ViewIntro_Text.Alpha -= 2; }
				if (ViewIntro_PressKey.Alpha > 0) { ViewIntro_PressKey.Alpha -= 3; }
				Blender -= 0.5;
				wait 1;
			}
			exit "";
		}

		if (key_any && Highscore.alpha > 99)
		{
			Snake_Speed = 5;
			SnakeLong = 1;
			Item_Now = 0;
			Item_Max = 0;
			HoleItem = 2;
			NowWait = 0;
			Score = 0;
			Lives = 6;
			Level = 1;
			Stop = 1;
			ViewIntro_Text.Visible = off;
			ShowScore_Off();
			while (Blender > 0)
			{
				if (ViewIntro_Text.Alpha > 0) { ViewIntro_Text.Alpha -= 2; }
				if (ViewIntro_PressKey.Alpha > 0) { ViewIntro_PressKey.Alpha -= 3; }
				Blender -= 0.5;
				wait 1;
			}
			while (Highscore.alpha > 0) { wait 1; }
			Stop = 0;
			load_lev();
		}
		wait 1;
	}
	wait 1;
}

action Gras
{
	my.passable = on;
	my.z += 15;
	my.pan = random(360);
	wait 1;
}

action Tree
{
	wait 1;
}

action Blend_Object
{
	my.passable = on;
	my.Transparent = on;
	my.alpha = 100;
	while (1)
	{
		my.alpha = Blender - 100;
		wait 1;
	}
}

action Blitz
{
	my.passable = on;
	my.invisible = on;
	while (1)
	{
		temp = random(250) + 500;
		wait temp;
		my.invisible = off;
		my.pan = random(360);
		my.tilt = -20 + random(40);
		my.roll = -10 + random(20);
		my.red = random(100);
		my.blue = random(100);
		my.green = random(100);
		my.lightred = random(100);
		my.lightblue = random(100);
		my.lightgreen = random(100);
		my.lightrange = random(100);
		my.light = on;
		play_entsound(my, Blitz_Sound, 300);
		temp = random(10);
		wait temp;
		my.pan = random(360);
		my.tilt = -20 + random(40);
		my.roll = -10 + random(20);
		my.red = random(100);
		my.blue = random(100);
		my.green = random(100);
		my.lightred = random(100);
		my.lightblue = random(100);
		my.lightgreen = random(100);
		my.lightrange = random(100);
		temp = random(10);
		wait temp;
		my.invisible = on;
		my.light = off;
	}
}

on_f2 null;
on_f3 null;
on_f5 null;
on_esc null;